Index: trunk/paper/CommPhysComp/notes.tex
===================================================================
--- trunk/paper/CommPhysComp/notes.tex	(revision 565)
+++ trunk/paper/CommPhysComp/notes.tex	(revision 569)
@@ -144,5 +144,5 @@
 
 
-\textit{Delphes} includes the most crucial experimental features, such as
+\textit{Delphes} includes important experimental features, such as
 (Fig.~\ref{fig:FlowChart}):
 \begin{enumerate}
@@ -164,5 +164,5 @@
 The kinematics variables of the final-state particles are then smeared
 according to the tunable subdetector resolutions. 
-Tracks are reconstructed in a simulated solenoidal magnetic field and
+Tracks are identified in a simulated solenoidal magnetic field and
 calorimetric cells sample the energy deposits. Based on these low-level objects,
 dedicated algorithms are applied for particle identification, isolation and
@@ -183,6 +183,5 @@
 ``parton-level" analysis, it has some limitations. Detector geometry is
 idealised, being uniform, symmetric around the beam axis, and having no cracks
-nor dead material. Secondary interactions, multiple scatterings, photon
-conversion and bremsstrahlung are also neglected.
+nor dead material. The propagated particles do not suffer secondary interactions nor multiple scatterings that would affect their integrity or path throughout the detector. Photon conversion and bremsstrahlung due to the magnetic field are also neglected.
 
 Several common datafile formats can be used as input in \textit{Delphes}
@@ -210,7 +209,7 @@
 conditions by modifying basic detector parameters, including calorimeter and
 tracking coverage and resolution, thresholds or jet algorithm parameters. 
-Even if \textit{Delphes} has been developped for the simulation of
+Even if \textit{Delphes} has been developed for the simulation of
 general-purpose detectors at the \textsc{LHC} (namely, \textsc{CMS} and
-\textsc{ATLAS}), this input parameter file interfaces a flexible parametrisation
+\textsc{ATLAS}, with references~\citep{bib:cmsjetresolution} and~\citep{bib:ATLASresolution} throughout this document), this input parameter file interfaces a flexible parametrisation
 for other cases, e.g.\ at future linear colliders~\citep{qr:datacards}.
 The geometrical coverage of the various subsystems used in the default
@@ -266,5 +265,6 @@
 By default, a track is assumed to be reconstructed with $90\%$ probability if
 its transverse momentum $p_T$ is higher than $0.9~\textrm{GeV}/c$ and if its
-pseudorapidity $|\eta| \leq 2.5$~\citep{qr:tracks}. This reconstruction efficiency is assumed to be uniform and independent of the particle type. No smearing is currently applied on track parameters. For each track, the positions at vertex $(\eta,\phi)$ and at the entry point in the calorimeter layers
+pseudorapidity $|\eta| \leq 2.5$~\citep{qr:tracks}. This reconstruction efficiency is assumed to be uniform and independent of the particle type. 
+The momentum of tracks undergoes an intrinsic smearing, corresponding to the experiment capabilities for given particles. No further smearing is currently applied on track parameters. For each track, the positions at vertex $(\eta,\phi)$ and at the entry point in the calorimeter layers
 $(\eta,\phi)_{calo}$ are available while the helix parameters of tracks, especially the impact parameters are not.
 
@@ -277,5 +277,6 @@
 characteristics are not identical in every direction, with typically finer
 resolution and granularity in the central
-regions~\citep{bib:cmsjetresolution,bib:ATLASresolution}. It is thus very
+regions. %~\citep{bib:cmsjetresolution,bib:ATLASresolution}. 
+It is thus very
 important to compute the exact coordinates of the entry point of the particles
 into the calorimeters, in taking the magnetic field effect into account.
@@ -293,5 +294,5 @@
 \begin{center}
 \includegraphics[width=\columnwidth]{fig3}
-\caption{Default segmentation of the calorimeters in the $(\eta,\phi)$ plane. Only the central detectors (\textsc{ECAL}, \textsc{HCAL}) and \textsc{FCAL} are considered. $\phi$ angles are expressed in radians.}
+\caption{Default segmentation of the calorimeters in the $(\eta,\phi)$ plane. Only the central detectors (\textsc{ECAL}, \textsc{HCAL}) and \textsc{FCAL} are considered. $\phi$ angles are expressed in radians (see Sec.~\ref{sec:config}).}
 \label{fig:calosegmentation}
 \end{center}
@@ -337,5 +338,5 @@
 
 
-Electrons and photons are assumed to leave their energy in the electromagnetic
+To simplify the simulation, electrons and photons are assumed to leave their energy in the electromagnetic
 parts of the calorimeters (\textsc{ECAL} and \textsc{FCAL}, e.m.), while charged
 and neutral final-state hadrons are assumed to leave their entire energy
@@ -345,18 +346,21 @@
 generators although they may decay before reaching the calorimeters. The energy
 smearing of such particles is therefore performed using the expected fraction of
-the energy, determined according to their decay products, that would be
-deposited into the \textsc{ECAL} ($E_{\textsc{ECAL}}$) and into the
-\textsc{HCAL} ($E_{\textsc{HCAL}}$). The positions of these deposits are identical to the one the mother particle would have hit.
-  Defining $F$ as the fraction of the energy
-leading to a \textsc{HCAL} deposit, the two energy values are given by
-\begin{equation}
-\left\{
-\begin{array}{l}
-E_{\textsc{HCAL}} = E \times F \\
-E_{\textsc{ECAL}} = E \times (1-F) \\
-\end{array}
-\right.
-\end{equation}
-where $0 \leq F \leq 1$. The resulting calorimetry energy measurement given
+the energy ($0 \leq F \leq 1$), determined according to their decay products, that would be
+deposited into the \textsc{ECAL} ($E_{\textsc{ECAL}} = (1-F)\times E$) and into the
+\textsc{HCAL} ($E_{\textsc{HCAL}} = F \times E$). 
+%The positions of these deposits are identical to the one the mother particle would have hit.
+The position of these deposits corresponds to the calorimeter entry point of the mother particle.
+%  Defining $F$ as the fraction of the energy
+%leading to a \textsc{HCAL} deposit, the two energy values are given by
+%\begin{equation}
+%\left\{
+%\begin{array}{l}
+%E_{\textsc{HCAL}} = E \times F \\
+%E_{\textsc{ECAL}} = E \times (1-F) \\
+%\end{array}
+%\right.
+%\end{equation}
+%where $0 \leq F \leq 1$. 
+The resulting calorimetry energy measurement given
 after the application of the smearing is then $E = E_{\textsc{HCAL}} +
 E_{\textsc{ECAL}}$. For $K_S^0$ and $\Lambda$ hadrons, the energy fraction $F$ is assumed to be $0.7$~\citep{qr:emhadratios}.\\
@@ -396,7 +400,7 @@
 The electron, muon and photon collections contains only the true final-state
 particles identified via the generator-data. In addition, these particles must
-pass fiducial cuts taking into account the magnetic field effects and have a
+pass fiducial cuts taking into account the magnetic field effects, have a
 transverse momentum above some threshold (default: $p_T > 10~\textrm{GeV}/c$). Consequently, no fake candidates enter these collections. As effects like bremsstrahlung are not taken into account along the lepton propagation in the tracker, no clustering is
-needed for the electron reconstruction in \textit{Delphes}. 
+needed for the electron reconstruction in \textit{Delphes}. Moreover, charged leptons are added in their respective collections if their associated track is available.
 
 %In your electron simulation you take only the energy from the electron itself, not from any physics bremsstrahlung that is often collinear with the electron (I mean the real emission bremststrahlung directly from the Z->ee decay, not from the magnetic field in the ID). This leads in Z->ee events to a visible distortion of the line shape. I am aware that there is no easy solution to this problem and just adding all photons in the same cell leads to bias for others reasons. However, the reader should be warned that the Z peak will be slightly shifted due to the missing bremsstrahlungs energy. 
@@ -406,10 +410,12 @@
 Real electron ($e^\pm$) and photon candidates are identified if they fall into the acceptance of the tracking system and have a
 transverse momentum above some threshold (default: $p_T > 10~\textrm{GeV}/c$). 
-\textit{Delphes} assumes a perfect
-algorithm for clustering and Brehmstrahlung recovery. Electron energy is smeared
-according to the resolution of the calorimetric cell where it points to, but
+\textit{Delphes} assumes a perfect algorithm for clustering and for recovery of detector-induced Brehmstrahlung.
+Electron energy is smeared according to the resolution of the calorimetric cell where it points to, but
 independently from any other deposited energy in this cell. 
 Electrons and photons may create a candidate in the jet collection. The $(\eta,
-\phi)$ position at vertex corresponds to corresponding track vertex.
+\phi)$ position at vertex comes from their corresponding track vertex. 
+As there is no associated track to photons, their reconstructed kinematics is less good than for electrons. Consequently, the mass resolution of di-photon resonances is affected.
+Similarly to full simulations, physics Brehmstrahlung from vertex is not taken into account in the electron reconstruction in \textit{Delphes}. Consequently, resonances like $Z\rightarrow e^+ e^-$ may have a bias in their reconstructed peak.
+
 
 \subsubsection*{Muons}
@@ -461,5 +467,6 @@
 available~\citep{bib:FASTJET,qr:jetalgo}: {\it CDF Jet Clusters}~\citep{bib:jetclu}, {\it CDF MidPoint}~\citep{bib:midpoint}, {\it Seedless Infrared Safe Cone}~\citep{bib:SIScone}, {\it Longitudinally invariant $k_t$ jet}~\citep{bib:ktjet}, {\it Cambridge/Aachen jet}~\citep{bib:aachen} and {\it Anti $k_t$ jet}~\citep{bib:antikt}. For all of them, the calorimetric
 cells are used as inputs. Jet algorithms differ in their sensitivity to soft
-particles or collinear splittings, and in their computing speed performances. By default, reconstruction uses the CDF cone algorithm. Jets are stored if their transverse energy is higher than $20~\textrm{GeV}$~\citep{qr:ptcutjet}. 
+particles or collinear splittings, and in their computing speed performances. By default, reconstruction uses the midpoint algorithm. Jets are stored if their transverse energy is higher than $20~\textrm{GeV}$~\citep{qr:ptcutjet}. 
+By construction, the jet energy scale is close to reality and should not be corrected. However, no corrections are applied if particles do not enter in the constituent list for the jet algorithm. This has an impact on the mass reconstruction of fully hadronic objects like $t$ quark or $W$ boson.
  
 
@@ -470,7 +477,5 @@
 particles associated to jets can be deduced from their associated track, thus
 providing a way to identify some of the components of cells with multiple hits.
-When the \textit{energy flow} is switched on in \textit{Delphes}, the energy of
-tracks pointing to calorimetric cells is subtracted and smeared separately,
-before running the chosen jet reconstruction algorithm. This option allows a
+When using \textit{energy flow} in \textit{Delphes}, the chosen jet algorithm is applied on the smeared energies of both the tracks and the modified calorimetric cells. To avoid double-counting, the energy in the calorimeter cells has been corrected by subtracting the true track energy from the true cell energy, before their smearing. This option allows a
 better jet energy reconstruction~\citep{qr:energyflow}.
  
@@ -494,5 +499,5 @@
 
 Jets originating from $\tau$-decays are identified using a procedure consistent
-with the one applied in a full detector reconstruction~\citep{bib:cmsjetresolution}.
+with the one applied in a full detector reconstruction. %~\citep{bib:cmsjetresolution}.
 The tagging relies on two properties of the $\tau$ lepton. First, $77\%$ of the
 $\tau$ hadronic decays contain only one charged hadron in combination with a few
@@ -504,5 +509,5 @@
 \begin{center}
 \includegraphics[width=0.80\columnwidth]{fig4}
-\caption{Illustration of the identification of $\tau$-jets ($1-$prong). The jet cone is narrow and contains only one track. The small cone serves to apply the \textit{electromagnetic collimation}, while the broader cone is used to reconstruct the jet originating from the $\tau$-decay.}
+\caption{Illustration of the identification of $\tau$-jets ($1-$prong). The jet cone is narrow and contains only one track. The small cone ($R^{em}$) serves to apply the \textit{electromagnetic collimation}, while the broader ($R^{tracks}$) cone is used to apply the \textit{tracking isolation}.}
 \label{h_WW_ss_cut1}
 \end{center}
@@ -579,5 +584,5 @@
 threshold on the $p_T$ of the $\tau$-jet candidate is requested to purify the
 collection. This procedure selects $\tau$ leptons decaying hadronically with a
-typical efficiency of $66\%$. 
+typical efficiency of $66\%$ relative to all hadronic $\tau$ decays. 
 
 \subsection{Missing transverse energy}
@@ -623,6 +628,5 @@
 forward final-state particles. In \textit{Delphes}, Zero Degree Calorimeters,
 roman pots and forward taggers have been implemented (Fig.~\ref{fig:fdets}),
-similarly as for CMS and ATLAS collaborations~\citep{bib:cmsjetresolution,
-bib:ATLASresolution}.
+similarly as for CMS and ATLAS collaborations. %~\citep{bib:cmsjetresolution,bib:ATLASresolution}.
 
 \begin{figure}[!ht]
@@ -782,10 +786,8 @@
 proportional to the number of simulated events and on the considered physics
 process. As an example, $10,000$ $pp \rightarrow t \bar t X$ events are
-processed in $110~\textrm{s}$ on a regular laptop and use less than
-$250~\textrm{MB}$ of disk space.
+processed in $110~\textrm{s}$ on a regular laptop\footnote{Performances obtained on an Intel(r) Pentium M processor ($1.73$ GHz), $1$ GB RAM, Chipset $915$GM. This processor scores $450$ on CpuMark benchmark from PassMark 2010 (c)~\citep{bib:cpumark}. In case of large amount of events, the duration of read/write operations on hard disk is sensible (about 6\% of the time for the $4400$ rpm hard disk of the precited computer) and might improve with fast storing devices.} and use less than $250~\textrm{MB}$ of disk space.
 The quality and validity of the output are assessed by comparing the
 resolutions on the reconstructed data to the expectations of both
-\textsc{CMS}~\citep{bib:cmsjetresolution} and
-\textsc{ATLAS}~\citep{bib:ATLASresolution} detectors.
+\textsc{CMS} and \textsc{ATLAS} detectors.
 
 Electrons and muons resolutions in \textit{Delphes} match by construction the
@@ -797,4 +799,5 @@
 
 \subsection{Jet resolution}
+\label{sec:jetresol}
  
 The majority of interesting processes at the \textsc{LHC} contain jets in the
@@ -844,5 +847,5 @@
 cone radius of $0.7$ and no energy flow correction. The maximum separation between the reconstructed and
 \textsc{MC}-jets is $\Delta R= 0.25$. Dotted line is the fit result for
-comparison to the \textsc{CMS} resolution~\citep{bib:cmsjetresolution}, in blue.
+comparison to the \textsc{CMS} resolution, in blue.
 The $pp \rightarrow gg$ dijet events have been generated with MadGraph/MadEvent
 and hadronised with \textit{Pythia}.}
@@ -860,6 +863,6 @@
 where $a$, $b$ and $c$ are the fit parameters. 
 It is then compared to the resolution published by the \textsc{CMS}
-collaboration~\citep{bib:cmsjetresolution}. The resolution curves from
-\textit{Delphes} and \textsc{CMS} are in good agreement.
+collaboration. The resolution curves from
+\textit{Delphes} and \textsc{CMS} are in good agreement: $3.1~\%$ at $E_T^\textrm{MC}=50~\textrm{GeV}$ and $4.2~\%$ at $500~\textrm{GeV}$. 
 
 Similarly, the jet resolution is evaluated for an \textsc{ATLAS}-like detector.
@@ -877,5 +880,5 @@
 obtained with \textit{Delphes}, the result of the fit with
 Equation~\ref{eq:fitresolution} and the corresponding curve provided by the
-\textsc{ATLAS} collaboration~\citep{bib:ATLASresolution}.
+\textsc{ATLAS} collaboration: $2.5~\%$ at $E^\textrm{MC}=50~\textrm{GeV}$ and $4.7\%$ at $500~\textrm{GeV}$.
 
 \begin{figure}[!ht]
@@ -889,5 +892,5 @@
 \textsc{MC}- and reconstructed jets is $\Delta R=0.2$. Only central jets are
 considered ($|\eta|<0.5$). Dotted line is the fit result for comparison to the
-\textsc{ATLAS} resolution~\citep{bib:ATLASresolution}, in blue. The $pp
+\textsc{ATLAS} resolution, in blue. The $pp
 \rightarrow gg$ di-jet events have been generated with MadGraph/MadEvent and
 hadronised with \textit{Pythia}.}
@@ -944,9 +947,9 @@
 events is $\sigma_x = (0.6-0.7) ~ \sqrt{E_T} ~ \mathrm{GeV}^{1/2}$ with no
 pile-up (i.e. extra simultaneous $pp$ collision occurring at high-luminosity in
-the same bunch crossing)~\citep{bib:cmsjetresolution}, which compares very well
+the same bunch crossing), which compares very well
 with the $\alpha = 0.63$ obtained with \textit{Delphes}. Similarly, for an
 \textsc{ATLAS}-like detector, a value of $0.53$ is obtained by \textit{Delphes}
 for the $\alpha$ parameter, while the experiment expects it in the range $[0.53~
-;~0.57]$~\citep{bib:ATLASresolution}.
+;~0.57]$.
 
 \subsection{\texorpdfstring{$\tau$}{\texttau}-jet efficiency}
@@ -963,5 +966,5 @@
 quoted for comparison. The level of agreement is satisfactory provided possible
 differences due to the event generation chain and the detail of reconstruction
-algorithms.
+algorithms. Using the same $pp \rightarrow ggX$ events as in section \ref{sec:jetresol} with a gluon transverse momentum at $80$ and $640~\textrm{GeV}/c$, the mis-identification rate of jets as $\tau\textrm{-jets}$ is evaluated at $6.4\times 10^{-4}$ and $1.7\times 10^{-4}$ respectively.
 
 \begin{table}[!h]
@@ -1010,6 +1013,6 @@
 the events themselves. The visibility of each set of objects ($e^\pm$,
 $\mu^\pm$, $\tau^\pm$, jets, transverse missing energy) is enhanced by a colour
-coding. Moreover, kinematics information of each object is visible by a simple
-mouse action. As an illustration, an associated photoproduction of a $W$ boson
+coding. Moreover, kinematics information of each object is also visible. 
+As an illustration, an associated photoproduction of a $W$ boson
 and a $t$ quark~\citep{bib:wtphotoproduction} is shown in Fig.~\ref{fig:wt}. 
 
@@ -1057,5 +1060,4 @@
 Part of this work was supported by the Belgian Federal Office for Scientific, Technical and Cultural Affairs through the Interuniversity Attraction Pole P6/11. 
 
-
 \begin{thebibliography}{99}
 \addcontentsline{toc}{section}{References}
@@ -1072,4 +1074,5 @@
 \bibitem{bib:cmsjetresolution} The \textsc{CMS} Collaboration, \textbf{CERN/LHCC} \href{http://documents.cern.ch/cgi-bin/setlink?base=LHCc&categ=public&id=LHCc-2006-001}{2006-001}.
 \bibitem{bib:ATLASresolution} The \textsc{ATLAS} Collaboration, \textbf{CERN-OPEN} 2008-020, \\arXiv:\href{http://arxiv.org/abs/arxiv:0901.0512}{0901.0512v1}[hep-ex].
+\bibitem{bib:cpumark} PassMark (r) software, \href{http://www.cpubenchmark.net/common\_cpus.html}{www.cpubenchmark.net}.
 \bibitem{bib:hector} %\textit{Hector}, \textit{a fast simulator for the transport of particles in beamlines},
 X. Rouby, J. de Favereau, K. Piotrzkowski, \textbf{JINST} \href{http://www.iop.org/EJ/abstract/1748-0221/2/09/P09005}{2 P09005 (2007)}.
@@ -1195,7 +1198,7 @@
 \subsection{Getting started}
  
-In order to run \textit{Delphes} on your system, first download its sources and compile them:\\
-\begin{quote}\texttt{wget http://www.fynu.ucl.ac.be/users/s.ovyn/Delphes/files/Delphes\_V\_*.tar.gz}\end{quote}
-Replace the \texttt{*} symbol by the proper version number. Always refer to the download page on the \textit{Delphes} website \href{http://www.fynu.ucl.ac.be/users/s.ovyn/Delphes/download.html}{http://www.fynu.ucl.ac.be/users/s.ovyn/Delphes/download.html}. Current version of Delphes for this manual is V 1.8 (July 2009).
+In order to run \textit{Delphes} on your system, first download source code and compile them:\\
+\begin{quote}\texttt{wget http://projects.hepforge.org/delphes/files/Delphes\_V\_*.tar.gz}\end{quote}
+Replace the \texttt{*} symbol by the proper version number. Current version of Delphes for this manual is V 1.8 (July 2009).
 
 \begin{quote}
@@ -1226,4 +1229,5 @@
  
 \subsubsection{Setting up the configuration}
+\label{sec:config}
  
 The program is driven by two datacards (default cards are {\verb data/DetectorCard.dat } and {\verb data/TriggerCard.dat }) which allow the user to choose among a large spectrum of running conditions. Please note that if the user does not provide these datacards, the running will be done using the default parameters defined in the constructor of the class \texttt{RESOLution} (see next). If you choose a different detector or running configuration, you will need to edit the datacards accordingly. Detector and trigger cards are provided in the \texttt{data/} subdirectory for the \textsc{CMS} and \textsc{ATLAS} experiments.
@@ -1389,5 +1393,5 @@
 VFD_s_zdc         140   // distance of the ZDC, from the IP, in [m]
 
-#\textit{Hector} parameters
+#Hector parameters
 RP_220_s          220     // distance of the RP to the IP, in meters
 RP_220_x          0.002   // distance of the RP to the beam, in meters
@@ -1396,5 +1400,5 @@
 RP_beam1Card      data/LHCB1IR5_v6.500.tfs // beam optics file, beam 1
 RP_beam2Card      data/LHCB2IR5_v6.500.tfs // beam optics file, beam 2
-RP_IP_name        IP5     // tag for IP in \textit{Hector} ; 'IP1' for ATLAS
+RP_IP_name        IP5     // tag for IP in Hector ; 'IP1' for ATLAS
 RP_offsetEl_x     0.097   // horizontal separation between both beam, in meters
 RP_offsetEl_y     0       // vertical separation between both beam, in meters