Index: external/PUPPI/PuppiAlgo.cc
===================================================================
--- external/PUPPI/PuppiAlgo.cc	(revision c0089234543ba2e87adb8f959d823ba682e6c2dc)
+++ external/PUPPI/PuppiAlgo.cc	(revision 659c7b6c6b8deb696fe0eb5ab84bf3c546f4e8fb)
@@ -1,6 +1,3 @@
-//#include "FWCore/ParameterSet/interface/ParameterSet.h"
-//#include "FWCore/PythonParameterSet/interface/MakeParameterSets.h"
 #include "PuppiAlgo.hh"
-#include "external/fastjet/internal/base.hh"
 #include "Math/QuantFuncMathCore.h"
 #include "Math/SpecFuncMathCore.h"
Index: external/PUPPI/PuppiAlgo.hh
===================================================================
--- external/PUPPI/PuppiAlgo.hh	(revision c0089234543ba2e87adb8f959d823ba682e6c2dc)
+++ external/PUPPI/PuppiAlgo.hh	(revision 659c7b6c6b8deb696fe0eb5ab84bf3c546f4e8fb)
@@ -1,4 +1,3 @@
-#include "external/fastjet/internal/base.hh"
-#include "external/fastjet/PseudoJet.hh"
+#include "fastjet/PseudoJet.hh"
 #include "AlgoObj.hh"
 #include <vector>
Index: external/PUPPI/PuppiContainer.cc
===================================================================
--- external/PUPPI/PuppiContainer.cc	(revision c0089234543ba2e87adb8f959d823ba682e6c2dc)
+++ external/PUPPI/PuppiContainer.cc	(revision 659c7b6c6b8deb696fe0eb5ab84bf3c546f4e8fb)
@@ -1,6 +1,4 @@
 #include "PuppiContainer.hh"
-#include "external/fastjet/internal/base.hh"
-#include "external/fastjet/Selector.hh"
-//#include "external/fastjet/FunctionOfPseudoJet.hh"
+#include "fastjet/Selector.hh"
 #include "Math/ProbFunc.h"
 #include "TMath.h"
Index: external/PUPPI/PuppiContainer.hh
===================================================================
--- external/PUPPI/PuppiContainer.hh	(revision c0089234543ba2e87adb8f959d823ba682e6c2dc)
+++ external/PUPPI/PuppiContainer.hh	(revision 659c7b6c6b8deb696fe0eb5ab84bf3c546f4e8fb)
@@ -1,6 +1,5 @@
 #include "PuppiAlgo.hh"
 #include "RecoObj2.hh"
-//#include "external/fastjet/internal/base.hh"
-#include "external/fastjet/PseudoJet.hh"
+#include "fastjet/PseudoJet.hh"
 #include <vector>
 
Index: external/PUPPI/puppiCleanContainer.hh
===================================================================
--- external/PUPPI/puppiCleanContainer.hh	(revision c0089234543ba2e87adb8f959d823ba682e6c2dc)
+++ external/PUPPI/puppiCleanContainer.hh	(revision 659c7b6c6b8deb696fe0eb5ab84bf3c546f4e8fb)
@@ -7,5 +7,4 @@
 #include "PUPPI/puppiAlgoBin.hh"
 
-#include "fastjet/internal/base.hh"
 #include "fastjet/PseudoJet.hh"
 #include <algorithm>
Index: modules/RunPUPPI.cc
===================================================================
--- modules/RunPUPPI.cc	(revision c0089234543ba2e87adb8f959d823ba682e6c2dc)
+++ modules/RunPUPPI.cc	(revision 659c7b6c6b8deb696fe0eb5ab84bf3c546f4e8fb)
@@ -3,6 +3,7 @@
 #include "PUPPI/RecoObj2.hh"
 #include "PUPPI/AlgoObj.hh"
-//#include "PUPPI/puppiParticle.hh"
-//#include "PUPPI/puppiAlgoBin.hh"
+#include "PUPPI/PuppiContainer.hh"
+
+#include "fastjet/PseudoJet.hh"
 
 #include "classes/DelphesClasses.h"
@@ -17,4 +18,5 @@
 
 using namespace std;
+using namespace fastjet;
 
 //------------------------------------------------------------------------------
@@ -238,8 +240,8 @@
   fPuppi->initialize(puppiInputVector);
   fPuppi->puppiWeights();
-  std::vector<fastjet::PseudoJet> puppiParticles = fPuppi->puppiParticles();
+  std::vector<PseudoJet> puppiParticles = fPuppi->puppiParticles();
 
   // Loop on final particles
-  for (std::vector<fastjet::PseudoJet>::iterator it = puppiParticles.begin() ; it != puppiParticles.end() ; it++) {
+  for (std::vector<PseudoJet>::iterator it = puppiParticles.begin() ; it != puppiParticles.end() ; it++) {
     if(it->user_index() <= int(InputParticles.size())){      
       candidate = static_cast<Candidate *>(InputParticles.at(it->user_index())->Clone());
Index: modules/RunPUPPI.h
===================================================================
--- modules/RunPUPPI.h	(revision c0089234543ba2e87adb8f959d823ba682e6c2dc)
+++ modules/RunPUPPI.h	(revision 659c7b6c6b8deb696fe0eb5ab84bf3c546f4e8fb)
@@ -3,10 +3,9 @@
 
 #include "classes/DelphesModule.h"
-#include "PUPPI/PuppiContainer.hh"
 #include <vector>
 
 class TObjArray;
 class TIterator;
-
+class PuppiContainer;
 
 class RunPUPPI: public DelphesModule {