Index: external/fastjet/tools/BackgroundEstimatorBase.cc
===================================================================
--- external/fastjet/tools/BackgroundEstimatorBase.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/BackgroundEstimatorBase.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: BackgroundEstimatorBase.cc 3433 2014-07-23 08:17:03Z salam $
+// $Id: BackgroundEstimatorBase.cc 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/BackgroundEstimatorBase.hh
===================================================================
--- external/fastjet/tools/BackgroundEstimatorBase.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/BackgroundEstimatorBase.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -3,7 +3,7 @@
 
 //FJSTARTHEADER
-// $Id: BackgroundEstimatorBase.hh 3516 2014-08-01 14:07:58Z salam $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: BackgroundEstimatorBase.hh 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/Boost.hh
===================================================================
--- external/fastjet/tools/Boost.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/Boost.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: Boost.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: Boost.hh 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/CASubJetTagger.cc
===================================================================
--- external/fastjet/tools/CASubJetTagger.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/CASubJetTagger.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: CASubJetTagger.cc 3433 2014-07-23 08:17:03Z salam $
+// $Id: CASubJetTagger.cc 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/CASubJetTagger.hh
===================================================================
--- external/fastjet/tools/CASubJetTagger.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/CASubJetTagger.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: CASubJetTagger.hh 3433 2014-07-23 08:17:03Z salam $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: CASubJetTagger.hh 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/Filter.cc
===================================================================
--- external/fastjet/tools/Filter.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/Filter.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: Filter.cc 4080 2016-03-09 15:01:57Z soyez $
+// $Id: Filter.cc 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/Filter.hh
===================================================================
--- external/fastjet/tools/Filter.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/Filter.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -3,7 +3,7 @@
 
 //FJSTARTHEADER
-// $Id: Filter.hh 3846 2015-03-08 08:35:43Z soyez $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: Filter.hh 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/GridMedianBackgroundEstimator.cc
===================================================================
--- external/fastjet/tools/GridMedianBackgroundEstimator.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/GridMedianBackgroundEstimator.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: GridMedianBackgroundEstimator.cc 3555 2014-08-11 09:56:35Z salam $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: GridMedianBackgroundEstimator.cc 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/GridMedianBackgroundEstimator.hh
===================================================================
--- external/fastjet/tools/GridMedianBackgroundEstimator.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/GridMedianBackgroundEstimator.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -3,7 +3,7 @@
 
 //FJSTARTHEADER
-// $Id: GridMedianBackgroundEstimator.hh 3969 2015-09-21 08:57:59Z salam $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: GridMedianBackgroundEstimator.hh 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/JHTopTagger.cc
===================================================================
--- external/fastjet/tools/JHTopTagger.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/JHTopTagger.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: JHTopTagger.cc 3433 2014-07-23 08:17:03Z salam $
+// $Id: JHTopTagger.cc 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/JHTopTagger.hh
===================================================================
--- external/fastjet/tools/JHTopTagger.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/JHTopTagger.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -3,7 +3,7 @@
 
 //FJSTARTHEADER
-// $Id: JHTopTagger.hh 3433 2014-07-23 08:17:03Z salam $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: JHTopTagger.hh 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/JetMedianBackgroundEstimator.cc
===================================================================
--- external/fastjet/tools/JetMedianBackgroundEstimator.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/JetMedianBackgroundEstimator.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: JetMedianBackgroundEstimator.cc 4047 2016-03-03 13:21:49Z soyez $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: JetMedianBackgroundEstimator.cc 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/JetMedianBackgroundEstimator.hh
===================================================================
--- external/fastjet/tools/JetMedianBackgroundEstimator.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/JetMedianBackgroundEstimator.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -3,7 +3,7 @@
 
 //FJSTARTHEADER
-// $Id: JetMedianBackgroundEstimator.hh 3517 2014-08-01 14:23:13Z soyez $
+// $Id: JetMedianBackgroundEstimator.hh 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/MassDropTagger.cc
===================================================================
--- external/fastjet/tools/MassDropTagger.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/MassDropTagger.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: MassDropTagger.cc 3433 2014-07-23 08:17:03Z salam $
+// $Id: MassDropTagger.cc 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -36,4 +36,5 @@
 
 LimitedWarning MassDropTagger::_warnings_nonca;
+LimitedWarning MassDropTagger::_negative_mass_warning;
 
 using namespace std;
@@ -71,4 +72,9 @@
   // the case
   while ((had_parents = j.has_parents(j1,j2))) {
+    if (j.m2() <= 0) {
+      _negative_mass_warning.warn(
+           "MassDropTagger: parent (sub)jet has mass^2<=0; returning null jet");
+      return PseudoJet();
+    }
     // make parent1 the more massive jet
     if (j1.m2() < j2.m2()) std::swap(j1,j2);
@@ -91,7 +97,6 @@
   PseudoJet result_local = j;
   MassDropTaggerStructure * s = new MassDropTaggerStructure(result_local);
-//  s->_original_jet = jet;
-  s->_mu = (j.m2()!=0.0) ? sqrt(j1.m2()/j.m2()) : 0.0;
-  s->_y  = (j.m2()!=0.0) ? j1.kt_distance(j2)/j.m2() : 0.0;
+  s->_mu = j1.m() / j.m();
+  s->_y  = j1.kt_distance(j2)/j.m2();
 
   result_local.set_structure_shared_ptr(SharedPtr<PseudoJetStructureBase>(s));
Index: external/fastjet/tools/MassDropTagger.hh
===================================================================
--- external/fastjet/tools/MassDropTagger.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/MassDropTagger.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: MassDropTagger.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: MassDropTagger.hh 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
@@ -110,4 +110,5 @@
   double _mu, _ycut;
   static LimitedWarning _warnings_nonca;
+  static LimitedWarning _negative_mass_warning;
 };
 
Index: external/fastjet/tools/Pruner.cc
===================================================================
--- external/fastjet/tools/Pruner.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/Pruner.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: Pruner.cc 3481 2014-07-29 17:24:12Z soyez $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: Pruner.cc 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/Pruner.hh
===================================================================
--- external/fastjet/tools/Pruner.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/Pruner.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -3,7 +3,7 @@
 
 //FJSTARTHEADER
-// $Id: Pruner.hh 3481 2014-07-29 17:24:12Z soyez $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: Pruner.hh 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/RestFrameNSubjettinessTagger.cc
===================================================================
--- external/fastjet/tools/RestFrameNSubjettinessTagger.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/RestFrameNSubjettinessTagger.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: RestFrameNSubjettinessTagger.cc 3433 2014-07-23 08:17:03Z salam $
+// $Id: RestFrameNSubjettinessTagger.cc 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/RestFrameNSubjettinessTagger.hh
===================================================================
--- external/fastjet/tools/RestFrameNSubjettinessTagger.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/RestFrameNSubjettinessTagger.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -3,7 +3,7 @@
 
 //FJSTARTHEADER
-// $Id: RestFrameNSubjettinessTagger.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: RestFrameNSubjettinessTagger.hh 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/Subtractor.cc
===================================================================
--- external/fastjet/tools/Subtractor.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/Subtractor.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: Subtractor.cc 3970 2015-09-21 10:31:17Z salam $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: Subtractor.cc 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/Subtractor.hh
===================================================================
--- external/fastjet/tools/Subtractor.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/Subtractor.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: Subtractor.hh 3970 2015-09-21 10:31:17Z salam $
-//
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// $Id: Subtractor.hh 4354 2018-04-22 07:12:37Z salam $
+//
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/TopTaggerBase.cc
===================================================================
--- external/fastjet/tools/TopTaggerBase.cc	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/TopTaggerBase.cc	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: TopTaggerBase.cc 3433 2014-07-23 08:17:03Z salam $
+// $Id: TopTaggerBase.cc 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/TopTaggerBase.hh
===================================================================
--- external/fastjet/tools/TopTaggerBase.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/TopTaggerBase.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -3,7 +3,7 @@
 
 //FJSTARTHEADER
-// $Id: TopTaggerBase.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: TopTaggerBase.hh 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------
Index: external/fastjet/tools/Transformer.hh
===================================================================
--- external/fastjet/tools/Transformer.hh	(revision 1d208a26c5a0e04af264db9dd7e0ec1daf2b8235)
+++ external/fastjet/tools/Transformer.hh	(revision 667a02abab10bed835e1186b81ddef9d3e67b782)
@@ -1,6 +1,6 @@
 //FJSTARTHEADER
-// $Id: Transformer.hh 3433 2014-07-23 08:17:03Z salam $
+// $Id: Transformer.hh 4354 2018-04-22 07:12:37Z salam $
 //
-// Copyright (c) 2005-2014, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
+// Copyright (c) 2005-2018, Matteo Cacciari, Gavin P. Salam and Gregory Soyez
 //
 //----------------------------------------------------------------------