Index: cards/delphes_card_FCC.tcl
===================================================================
--- cards/delphes_card_FCC.tcl	(revision 221abf32bf9c47856e9e3c0977f39d3680383970)
+++ cards/delphes_card_FCC.tcl	(revision 679a87e6351b4357cc7393b61683b909009af212)
@@ -145,7 +145,7 @@
 
   # resolution formula for charged hadrons
-  set ResolutionFormula {    (abs(eta) <= 1.5)                   * (pt > 0.1) * (0.01 + pt*2.e-5) +
-                             (abs(eta) > 1.5 && abs(eta) <= 4.0) * (pt > 0.1) * (0.02 + pt*3.e-5) +
-                             (abs(eta) > 4.0 && abs(eta) <= 6.0) * (pt > 0.1) * (0.03 + pt*5.e-5)}
+  set ResolutionFormula {    (abs(eta) <= 1.5)                   * (pt > 0.1) * sqrt(0.01^2 + pt^2*2.e-5^2) +
+                             (abs(eta) > 1.5 && abs(eta) <= 4.0) * (pt > 0.1) * sqrt(0.02^2 + pt^2*3.e-5^2) +
+                             (abs(eta) > 4.0 && abs(eta) <= 6.0) * (pt > 0.1) * sqrt(0.03^2 + pt^2*5.e-5^2)}
 
 
@@ -163,7 +163,7 @@
 
   # resolution formula for electrons
-  set ResolutionFormula {    (abs(eta) <= 1.5)                   * (pt > 0.1) * (0.01 + pt*2.e-5) +
-                             (abs(eta) > 1.5 && abs(eta) <= 4.0) * (pt > 0.1) * (0.02 + pt*3.e-5) +
-                             (abs(eta) > 4.0 && abs(eta) <= 6.0) * (pt > 0.1) * (0.03 + pt*5.e-5)}
+ set ResolutionFormula {     (abs(eta) <= 1.5)                   * (pt > 0.1) * sqrt(0.01^2 + pt^2*2.e-5^2) +
+                             (abs(eta) > 1.5 && abs(eta) <= 4.0) * (pt > 0.1) * sqrt(0.02^2 + pt^2*3.e-5^2) +
+                             (abs(eta) > 4.0 && abs(eta) <= 6.0) * (pt > 0.1) * sqrt(0.03^2 + pt^2*5.e-5^2)}
 
 }
@@ -180,7 +180,7 @@
 
   # resolution formula for muons
-  set ResolutionFormula {    (abs(eta) <= 1.5)                   * (pt > 0.1) * (0.01 + pt*5.0e-6) +
-                             (abs(eta) > 1.5 && abs(eta) <= 4.0) * (pt > 0.1) * (0.02 + pt*1.0e-5) +
-                             (abs(eta) > 4.0 && abs(eta) <= 6.0) * (pt > 0.1) * (0.03 + pt*1.5e-5)}
+  set ResolutionFormula {    (abs(eta) <= 1.5)                   * (pt > 0.1) * sqrt(0.01^2 + pt^2*5.0e-6^2) +
+                             (abs(eta) > 1.5 && abs(eta) <= 4.0) * (pt > 0.1) * sqrt(0.02^2 + pt^2*1.0e-5^2) +
+                             (abs(eta) > 4.0 && abs(eta) <= 6.0) * (pt > 0.1) * sqrt(0.03^2 + pt^2*1.5e-5^2)}
 
 
Index: cards/delphes_card_ILD.tcl
===================================================================
--- cards/delphes_card_ILD.tcl	(revision 221abf32bf9c47856e9e3c0977f39d3680383970)
+++ cards/delphes_card_ILD.tcl	(revision 679a87e6351b4357cc7393b61683b909009af212)
@@ -124,6 +124,6 @@
 
   # resolution formula for charged hadrons
-  set ResolutionFormula {    (abs(eta) <= 1.0)                   * (0.001 + pt*1.e-5) +
-                             (abs(eta) > 1.0 && abs(eta) <= 2.4) * (0.01 + pt*1.e-4)}
+  set ResolutionFormula {    (abs(eta) <= 1.0)                   * sqrt(0.001^2 + pt^2*1.e-5^2) +
+                             (abs(eta) > 1.0 && abs(eta) <= 2.4) * sqrt(0.01^2 + pt^2*1.e-4^2)}
 
 
@@ -140,7 +140,7 @@
   # set ResolutionFormula {resolution formula as a function of eta and energy}
 
-  # resolution formula for electrons (we keep nominal tracking reso since ECAL can't beat this, even at high E)
-  set ResolutionFormula {    (abs(eta) <= 1.0)                   * (0.001 + pt*1.e-5) +
-                             (abs(eta) > 1.0 && abs(eta) <= 2.4) * (0.01 + pt*1.e-4)}
+   # resolution formula for charged hadrons
+  set ResolutionFormula {    (abs(eta) <= 1.0)                   * sqrt(0.001^2 + pt^2*1.e-5^2) +
+                             (abs(eta) > 1.0 && abs(eta) <= 2.4) * sqrt(0.01^2 + pt^2*1.e-4^2)}
 }
 
@@ -155,8 +155,7 @@
   # set ResolutionFormula {resolution formula as a function of eta and pt}
 
-  # resolution formula for muons
-  set ResolutionFormula {    (abs(eta) <= 1.0)                   * (0.001 + pt*1.e-5) +
-                             (abs(eta) > 1.0 && abs(eta) <= 2.4) * (0.01 + pt*1.e-4)}
-
+   # resolution formula for charged hadrons
+  set ResolutionFormula {    (abs(eta) <= 1.0)                   * sqrt(0.001^2 + pt^2*1.e-5^2) +
+                             (abs(eta) > 1.0 && abs(eta) <= 2.4) * sqrt(0.01^2 + pt^2*1.e-4^2)}
 
 }